Bug 1476153 - [RFE] libsmbclient should not terminate a connection in case it receives an SMB2 ECHO Response with an error
[RFE] libsmbclient should not terminate a connection in case it receives an S...
Status: ASSIGNED
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: samba (Show other bugs)
7.4
All Linux
medium Severity medium
: rc
: ---
Assigned To: Andreas Schneider
qe-baseos-daemons
: FutureFeature
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-28 03:24 EDT by Thorsten Scherf
Modified: 2017-10-25 04:58 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Samba Project 13007 None None None 2017-08-31 08:57 EDT

  None (edit)
Description Thorsten Scherf 2017-07-28 03:24:51 EDT
Description of problem:

According to the specs, a SMB server should answer an SMB2 ECHO Request with STATUS_SUCCESS to demonstrate it's responsive and can process requests. In some cases SMB servers might not be able to handle ECHO Requests with a Session ID 0 (which is completely valid according to the specs) and return an ERROR instead. As a result, smblclient currently terminates the network connection:

017-07-17 14:00:40.873514 192.168.220.211 → 149.78.138.25 SMB2 138 KeepAlive Request
2017-07-17 14:00:40.873637 149.78.138.25 → 192.168.220.211 SMB2 143 KeepAlive Response, Error: STATUS_USER_SESSION_DELETED
2017-07-17 14:00:40.873676 192.168.220.211 → 149.78.138.25 TCP 66 51296 → 445 [FIN, ACK] Seq=1632 Ack=1395 Win=35712 Len=0 TSval=2284796732 TSecr=2066    075117

We reached out to Microsoft to get some clarification what exactly the client is supposed to do in such a case. Here is the answer:

"""
Client behavior in regards to ECHO is implementation-specific (there is no mention in section 3.2). ECHO is merely a keep-alive ping to see if the server is responsive, so any response could be considered success. All the Server does (besides disconnecting the connection if Connection.SessionTable is empty) is validate the structure of the request. If the server returns STATUS_INVALID_PARAMETER, this indicates the Client formed the request incorrectly, but shows the Server is responsive (as does any response, error or success).
"""

This RfE is about a change in current libsmbclient behavior. The client *should not* terminate the network connection in case an error is returned from the server and should continue processing SMB commands instead.
 

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

Note You need to log in before you can comment on or make changes to this bug.